// 10.1 Lineární regrese (podle vzorců)
//V letech 1975 - 2015 jsme zaznamenávali požadavky na parkovací 
//místa v Praze 4. Zajímá nás 
//(i) zda požadavky mají tendenci nárůstu, 
//(ii) jaký je odhad počtu požadavků pro rok 2020 a 
//(iii) kdy bude požadavek na parkování dvojnásobný, než byl v roce 2015?
// ----------------------------------------------------------
clear, close
exec spust_pri_startu.sce, mode(0), clc

// roky
x=1975:2015;
// požadavky na parkování v tis.
y=[27.88  42.75  51.23  48.44  46.02  42.52  45.72  58.27  ..
   45.88  31.5   43.04  25.58  34.66  34.79  50.64  46.24  ..
   41.61  48.24  34.17  38.22  36.26  32.12  73.76  39.87  ..
   30.41  57.52  49.19  20.24  35.72  57.91  48.77  58.62  ..
   45.48  51.76  36.88  47.36  49.61  47.4   61.04  48.22  ..
   48.49];
   
nx=length(x);                 // počet dat
mx=mean(x);                   // průměr x
my=mean(y);                   // průměr y
Sxy=sum((x-mx).*(y-my));      // součet součinů x a y
S2x=sum((x-mx)^2);            // součet kvadrátů x
S2y=sum((y-my)^2);            // spučet kvadrátů y

// regresní přímka
b1=Sxy/sqrt(S2x*S2y)          // regresní koeficient
b0=my-b1*mx                   // absolutní člen

// predikce
yp=b1*x+b0;

// výsledky
plot(1:nx,y,'.',1:nx,yp)
legend('y','yp');

// odpovědi
// (i) b1>0 - tendence nárůstu

// (ii)
disp 'kolik bude v roce 2020'
x0=2020;
yp=b1*x0+b0

// (iii)
disp 'kdy bude dvojnásobek z roku 2015'
y0=2*y(nx);
x0=(y0-b0)/b1
